//****************************************************************************************
// Name: Counter-Bot Metamod
// Author: He@dShot
// Version: 1.0
// Description: Counter-Strike 1.6 Bot
// Started: Monday May 2008; 11:56 PM
// Copyright He@dShot 2008, All rights reserved !
// 
// Bot_Waypoint.h
//****************************************************************************************
#ifndef BOT_WAYPOINT_INCLUDED
#define BOT_WAYPOINT_INCLUDED

#define LOCATION Vector
#define MAX_WAYPOINTS 1024 // Total max waypoints in a map
#define MAX_PATH_INDEX 8
//========================================================================================
enum Waypoint_Flags
{ 
   WPT_FLAG_NORMAL = (1 << 0),  
   WPT_FLAG_BUTTON = (1 << 1),  // nearby button (lifts, doors, etc.) flag
   WPT_FLAG_LIFT = (1 << 2),    // wait for lift to be down before approaching this waypoint
   WPT_FLAG_CROUCH = (1 << 3),
   WPT_FLAG_BOMB_SITE = (1 << 4),
   WPT_FLAG_HOSTAGE_POINT = (1 << 5),
   WPT_FLAG_LADDER = (1 << 6),
   WPT_FLAG_RESCUE = (1 << 7),
   WPT_FLAG_CAMP = (1 << 8),
   WPT_FLAG_ESCAPE = (1 << 9),
   WPT_FLAG_T_SPAWN = (1 << 10),
   WPT_FLAG_CT_SPAWN = (1 << 11),
   WPT_FLAG_CAMP_AIMING = (1 << 12)
};
//========================================================================================
// WAYPOINT STRUCTURE DEFINITION
//========================================================================================
typedef struct Waypoint
{    
	char wptFilename[10]; // The name of the waypoint file when saving waypoints
	int Number_of_waypoints; // Total number of waypoints in the map
    char Waypoint_map_name[32]; // Map name when loading waypoints
    char Author[32]; // Name of the waypoint author
} WAYPOINT_T;
//========================================================================================
typedef struct Experience
{
  char expFilename[10]; // The name of the experience file when saving experience
  int Number_of_waypoints; // Total number of waypoints in the map
} EXPERIENCE_T;
//========================================================================================
typedef struct VisTable
{
  char visFilename[10]; // The name of the visibility table file when saving visiblity
  int Number_of_waypoints; // Total number of waypoints in the map

} VISTABLE_T;
//========================================================================================
typedef struct Path  /*paths are connections between two waypoint nodes that indicates the bot can get from point A to point B.*/
{
} PATH_T;
//========================================================================================

#endif