//****************************************************************************************
// Name: Counter-Bot Metamod
// Author: He@dShot
// Version: 1.0
// Description: Counter-Strike 1.6 Bot
// Started: Monday May 2008; 11:56 PM
// Copyright He@dShot 2008, All rights reserved !
// Started from PodBot_mm & Yapb ! Thanks and credits go to the authors.
//
// Bot_MainCode.cpp
//****************************************************************************************
//========================================================================================
// Standard includes
#define _CRT_SECURE_NO_WARNINGS 1          // Disable compiler warnings sent by old functions
#include <stdio.h>
#include <string.h>
#include <extdll.h>
#include <dllapi.h>
#include <h_export.h>
#include <meta_api.h>
#include <windows.h>
// Bot includes
#include "..\Header Files\Bot_Engine.h"   // Engine header file
#include "..\Header Files\Bot_Globals.h"  // Globals header file
#include "..\Header Files\Bot_Waypoint.h" // Waypoint header file
//========================================================================================
//
//											GLOBALS
//
//========================================================================================
int g_MapType                 = (0 << 0); // Current map type: 1 - ASSASINATION MAP (AS); 2 - HOSTAGE MAP (CS); 3 - DEFUSAL MAP (DE); 4 - ESCAPE MAP (ES) 
int g_GameVersion             = 0;   // Game Version: 0 = Counter-Strike 1.6; 1 - Steam Counter-Strike 1.6
int g_CurrentState            = 0;   // Current bot state: Seeing enemy or hearing enemy
int g_NumberOfBots            = 0;   // number of bots in the game
int g_NumberOfWaypoints       = 0;   // number of waypoints in the map
int g_BotNamesIndex           = 0;   // Total number of bot names
int g_Cvar_BotMinSkill        = 0;	 // minimum skill CVAR
int g_Cvar_BotMaxSkill        = 0;   // maximum skill CVAR
int g_Cvar_ThinkFPS           = 0;   // FPS thinking timer CVAR
int g_botIndex                = 0;

char g_WelcomeMessage[]       = "Welcome to CounterBot_MM ! Visit http://www.bots-united.com/ - The Bot Community !";

// Clients
edict_t *Clients[32];				 // Clients (Max:32)
Bot_t m_bot[32];					 // Bot array (Max:32)

enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;
float FPS_timer;
float g_RestartServerTimer = 0.0;

// MSEC
unsigned char m_msecVal = 0;;
float m_msecDel,m_msecNum = 0;

//========================================================================================
//
//									START UTILITY FUNCTIONS
//
//========================================================================================
// GetMsecValue - This function estimates the next frame duration and returns it's value (MSEC)
//========================================================================================
int GetMsecValue (void)
{
	if (m_msecDel > GetWorldTime ())
         m_msecNum += 1.0;
      else
      {
         if (m_msecNum > 0.0)
            m_msecVal = static_cast <byte> (450.0 / m_msecNum);

         m_msecDel = GetWorldTime () + 0.5; // next check in half a second
         m_msecNum = 0.0;
      }
   return m_msecVal;
}
//========================================================================================
// ConsolePrint - Prints a message on the console
//========================================================================================
void ConsolePrint( char *text )
{
	g_engfuncs.pfnServerPrint( text );
} /* Prints a message on the console ! */
//========================================================================================
// ClientPrint - Prints a message to the specified player
//========================================================================================
void ClientPrint( edict_t* pEdict, PRINT_TYPE ptype, const char *szMsg )
{
	g_engfuncs.pfnClientPrintf(  pEdict, ptype, szMsg );
} /* Prints a message to the specified player ! */
//========================================================================================
// CREATE FAKE CLIENT - Creates a fake client
//========================================================================================
inline edict_t *CREATE_FAKE_CLIENT( const char *netname )
{
   return (*g_engfuncs.pfnCreateFakeClient)( netname );
}
//========================================================================================
inline char *GET_KEY_INFOBUFFER( edict_t *e )
{
   return (*g_engfuncs.pfnGetInfoKeyBuffer)( e );
}
//========================================================================================
inline void SET_CLIENT_KEY_VALUE( int clientIndex, char *infobuffer, char *key, char *value )
{
	
   (*g_engfuncs.pfnSetClientKeyValue)( clientIndex, infobuffer, key, value );
}
//========================================================================================
int pfnRegUserMsg(const char *pszName, int iSize)
{
	return 0;
}
//========================================================================================
// MESSAGE_BEGIN - Handles entire network messages sent troughout the game to clients
//========================================================================================
void pfnMessageBegin( int msg_dest, int msg_type, const float *pOrigin, edict_t *ed) 
{     
	    int i = ENTINDEX(ed)-1;
		   if (ed != NULL && m_bot[i].pEdict != NULL && g_IsBot[i])    // check first if the current message is sent for a bot player
		{

		 if (msg_type == GET_USER_MSG_ID (PLID, "VGUIMenu", NULL))           
		 {
             m_bot[i].i_currentNetMessage = NetMessage_VGui;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "ShowMenu", NULL))
		 {	
             m_bot[i].i_currentNetMessage = NetMessage_ShowMenu;
		 }         
         else if (msg_type == GET_USER_MSG_ID (PLID, "StatusIcon", NULL))
		 {
             m_bot[i].i_currentNetMessage = NetMessage_StatusIcon;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "CurWeapon", NULL))
		 {
             m_bot[i].i_currentNetMessage = NetMessage_CurWeapon;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoX", NULL))
		 {
             m_bot[i].i_currentNetMessage = NetMessage_AmmoX;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "AmmoPickup", NULL))
		 {
             m_bot[i].i_currentNetMessage = NetMessage_AmmoPickup;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "Damage", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_Damage;
		 } 
         else if (msg_type == GET_USER_MSG_ID (PLID, "Money", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_Money;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "ScreenFade", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_ScreenFade;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "BombDrop", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_BombDrop;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "BombPickup", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_BombPickup;
		 }
         else if (msg_type == GET_USER_MSG_ID (PLID, "SayText", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_SayText;
		 }
		 else if (msg_type == GET_USER_MSG_ID (PLID, "BotVoice", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_BotVoice;
		 }
		 else if (msg_type == GET_USER_MSG_ID (PLID, "SendAudio", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_SendAudio;
		 }
		 else if (msg_type == GET_USER_MSG_ID (PLID, "BarTime", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_BarTime;
		 }

		 // HLTV - Counter-Strike 1.6
		 if(msg_dest == MSG_SPEC && msg_type == GET_USER_MSG_ID (&Plugin_info, "HLTV", NULL))
		 {
			 m_bot[i].i_currentNetMessage = NetMessage_HLTV;
		 }

		 else if (msg_dest == MSG_ALL)
		 {

			 if (msg_type == GET_USER_MSG_ID (PLID, "DeathMsg", NULL))
                   m_bot[i].i_currentNetMessage = NetMessage_DeathMsg;
			 else if (msg_type == GET_USER_MSG_ID (PLID, "WeaponList", NULL))
                   m_bot[i].i_currentNetMessage = NetMessage_WeaponList;
			 else if (msg_type == GET_USER_MSG_ID (PLID, "TextMsg", NULL))
			       m_bot[i].i_currentNetMessage = NetMessage_TextMsg;
		 }
	   }
   RETURN_META(MRES_IGNORED);
}
//========================================================================================
void pfnMessageEnd( void )
{
	RETURN_META(MRES_HANDLED);
}
//========================================================================================
void pfnRunPlayerMove(edict_t *fakeclient, const float *viewangles, float forwardmove, float sidemove, float upmove, unsigned short buttons, byte impulse, byte msec )
{
  (*g_engfuncs.pfnRunPlayerMove)( fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, msec);
}
//========================================================================================

//========================================================================================
bool InitializationFileExists( char *iniName )
{   FILE *cfgFile;
    if (iniName == "CounterBot_mm.ini")
	{
		cfgFile = fopen("cstrike/addons/CounterBot_MM/CounterBot_mm.ini", "r");
	   if (cfgFile != NULL)
	   {

        fclose(cfgFile);

	   return true;
	   }  
	}
	else if (iniName == "Names.ini")
	{
       cfgFile = fopen("cstrike/addons/CounterBot_MM/Names.ini", "r");
	   if (cfgFile != NULL)
	   {

        fclose(cfgFile);
          
	   return true;
	   }
	   
	}
	else if (iniName == "Chatter.ini")
	{
		cfgFile = fopen("cstrike/addons/CounterBot_MM/Chatter.ini", "r");
	   if (cfgFile != NULL)
	   {
  
        fclose(cfgFile);

	   return true;
	   }  
	}
	return false; // if none of the above settings return true value, return false !
}/* Returns TRUE if CounterBot_MM configuration files exists and can be loaded*/
//========================================================================================
void LoadConfigurationFiles(void)
{
	// *** BOT CONFIGURATION FILE LOADING ***
	if (InitializationFileExists("CounterBot_mm.ini"))
	{
      // Insert your code here...
      ConsolePrint("CounterBot_mm - CounterBot_mm configuration file succesfully loaded...! \n");
	}
	else 
      ConsolePrint("CounterBot_mm - Cannot find CounterBot_mm configuration file...! \n");

	// *** NAMES CONFIGURATION FILE LOADING ***
	if ( InitializationFileExists("Names.ini"))
	{
      // Insert your code here...
      ConsolePrint("CounterBot_mm - Names configuration file succesfully loaded...! \n");
	}
	else 
      ConsolePrint("CounterBot_mm - Cannot find names configuration file...! \n");

	// *** CHATTER CONFIGURATION FILE LOADING ***
    if ( InitializationFileExists("Chatter.ini"))
	{
      // Insert your code here...
      ConsolePrint("CounterBot_mm - Chatter configuration file succesfully loaded...! \n");
	}
	else 
      ConsolePrint("CounterBot_mm - Cannot find chatter configuration file...! \n");
}/* Returns TRUE if CounterBot_MM configuration file exists and can be loaded*/
//========================================================================================
bool ConditionZeroModelsExist( bool Tmodel, bool CTmodel )
{   FILE *modelfile;
    // First see if we need to check for Militia model
if (Tmodel && !CTmodel)
{
	modelfile = fopen ("cstrike/models/player/militia/militia.mdl", "r");
	if(modelfile != NULL)
	{
	  if(g_IsDebugMode) // if debug mode is enabled print a message telling that model exists
	  {
		  ConsolePrint("[DEBUG] Condition-Zero, Militia model exists in **cstrike/models/militia** directory");
	  }
      
	  fclose(modelfile); // close the model file to avoid memory leaks and data loss

     return true;
	}
	else
	{
		if (!g_IsDebugMode) // if debug mode is enabled print a message telling that model doesn't exists
		{
		  ConsolePrint("[DEBUG] Condition-Zero, Militia model does not exists in **cstrike/models/militia** directory");
		}
		
		return false;
	}

}
else if (!Tmodel && CTmodel)
{
   modelfile = fopen ("cstrike/models/player/spetsnaz/spetsnaz.mdl", "r");
	if(modelfile != NULL)
	{
	  if(g_IsDebugMode) // if debug mode is enabled print a message telling that model exists
	  {
		  ConsolePrint("[DEBUG] Condition-Zero, Spetsnaz model exists in **cstrike/models/spetsnaz** directory");
	  }
     
      fclose(modelfile); // close the model file to avoid memory leaks and data loss

     return true;
	}
	else 
	{
		if (!g_IsDebugMode) // if debug mode is enabled print a message telling that model doesn't exists
	{
		  ConsolePrint("[DEBUG] Condition-Zero, Spetsnaz model does not exists in **cstrike/spetsnaz** directory");
		}
		return false;
	}

}
	return false; // if none of the above settings return true value, return false !
}/* Returns TRUE if the model directory and filename exists in the "cstrike\models\" directory*/
//========================================================================================
int CompareStringsBinary( const char *text1, const char *text2 )
{
   return strcmp( text1, text2 );
}/* Compares two binary strings and returns the difference*/
//========================================================================================
void FreeLibraryMemory(void)
{
} /* Unalocates memory upon server restart, map change or HL shutdown !*/
//========================================================================================
edict_t *GetEntityByIndex(int entIndex )
{
	return INDEXENT( entIndex );
} /* Return an entity "edict_t" from it's entity index */
//========================================================================================
int GetEntityIndex(edict_t *ent )
{
	return ENTINDEX( ent );
}/* Return an entity's index */
//========================================================================================
// GetMaxClients - This function returns the number of the current players on server
//========================================================================================
inline int GetMaxClients (void)
{
	return gpGlobals->maxClients;
}
//========================================================================================
// GetWorldTime- This function returns the engine current time on the server
//========================================================================================
inline float GetWorldTime (void)
{
	return gpGlobals->time;
}
//========================================================================================
float GetCvarValue (const char *cvarName)
{
	return (*g_engfuncs.pfnCVarGetFloat)(cvarName);
}
//========================================================================================
bool IsNamesFileValid (void)
{
	// Check to see if Names.ini exists first...
    if( InitializationFileExists("Names.ini") )
	{
		return true; // file exists, return true
	}
	// Now that the names file exists, check if it has a valid number of bot names
	// TODO:
	// Insert your code here...!
	return false;
}
//========================================================================================
void UpdateCvars(void)
{ 

} /* Updates all bot cvars ! */
//========================================================================================
// INITIALIZE BOT SKILL - This function sets up a bot's difficulty skills after creation
//========================================================================================
void InitializeBotSkill(Bot_t *wichBot )
{
	Bot_t *bot = wichBot;
}
//========================================================================================
void ClientCommand (edict_t *ent, char *format, ...)
{
	RETURN_META(MRES_IGNORED);
}
//========================================================================================
void FakeClientCommand(edict_t *pBot, char *arg1, char *arg2, char *arg3)
{
   int length;

   memset(g_argv, 0, 1024);

   isFakeClientCommand = TRUE;

   if ((arg1 == NULL) || (*arg1 == 0))
      return;

   if ((arg2 == NULL) || (*arg2 == 0))
   {
      length = sprintf(&g_argv[0], "%s", arg1);
      fake_arg_count = 1;
   }
   else if ((arg3 == NULL) || (*arg3 == 0))
   {
      length = sprintf(&g_argv[0], "%s %s", arg1, arg2);
      fake_arg_count = 2;
   }
   else
   {
      length = sprintf(&g_argv[0], "%s %s %s", arg1, arg2, arg3);
      fake_arg_count = 3;
   }

   g_argv[length] = 0;  // null terminate just in case

   strcpy(&g_argv[64], arg1);

   if (arg2)
      strcpy(&g_argv[128], arg2);

   if (arg3)
      strcpy(&g_argv[192], arg3);

   // Allow the MOD DLL to execute the ClientCommand
   MDLL_ClientCommand(pBot);

   isFakeClientCommand = FALSE;
}
//========================================================================================
//========================================================================================
//========================================================================================
//
//									END UTILITY FUNCTIONS
//
//========================================================================================
//========================================================================================
//
//											  BOT
//
//========================================================================================
//========================================================================================
// Bot AI - The main function of the Bot's AI. Handles entire bot system. Gets called every frame.
//========================================================================================
void BotAI( Bot_t *botPlayer )
{ // *** AI EXECUTION START ***
	Bot_t *botEdict = botPlayer;
	edict_t *botEnt = botPlayer->pEdict; // link to player entity
	edict_t *enemy = botPlayer->pEdict->v.enemy; // link to bot enemy entity

  // ***** pnfRunPlayerMove *****
	pfnRunPlayerMove(botEnt,botEnt->v.v_angle,0.0, 0, 0, 0, 0, GetMsecValue());
} // *** AI EXECUTION END ***
//========================================================================================
void FireWeapon(Bot_t *bot)
{
}
//========================================================================================
edict_t GetNewEnemy(Bot_t *bot, edict_t *oldEnemy )
{
  return *oldEnemy;
}
//========================================================================================
bool UsesWeakWeapon(Bot_t *bot)
{
	return false;
}
//========================================================================================
void ThrowGrenadeAtLocation(Bot_t *bot, Vector location, int GrenadeType)
{
}
//========================================================================================
bool IsBehindSmokeClouds(edict_t *ent)
{
	return false;
}
//========================================================================================
bool UsesPistol(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool UsesRifle(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool UsesGrenade(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool UsesSniper(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool UsesSubMachineGun(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool UsesMachineGun(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool UsesShotgun(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool HasPistol(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool HasRifle(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool HasSubMachineGun(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool HasMachineGun(Bot_t *bot)
{
	return false;
}
//========================================================================================
bool HasGrenades(Bot_t *bot, int grenadeType)
{
	int weapon = bot->pEdict->v.weapons;

   if (weapon & (1 << grenadeType))
      return true;
	return false;
}
//========================================================================================
bool IsEntityVisibleToEntity(edict_t *entity, edict_t *target)
{
	return false;
}

//========================================================================================
// 
//										BOT MANAGER
//
//========================================================================================
//========================================================================================
// CREATE BOT - Creates a bot upon specified parameters
//
// Parameter1: Name - Name the bot uses ingame
// Parameter2: Team - The team the bot should join
// Parameter3: Model - The model the bot should use
// Parameter4: Personality: The bot's personality 
// Parameter5: Class: The bot's player class ingame
// Parameter6: Difficulty: The bot's skill difficulty
//========================================================================================
void CreateBot(const char *Name, int Team, const char *Model, int Profile, int Skill)
{
	edict_t *bot;
	Bot_t *s_bot;
	char connectMessage[128];
	int index;
	//----------------------------------------------------
	// Don't allow creating bot when map has no waypoints
	//----------------------------------------------------
 	if(g_NumberOfWaypoints > 0)
	{
		ConsolePrint( ERROR_MESSAGE_NO_WPTS_BOT_CREATION_ABORTED );
		return;
	}
	else // Waypoints found, create the bot...!
	{
		// Check if maximum players reached
		index = 0;
		while ((m_bot[index].b_SlotUsed) && (index < 32))
         index++;

		if (index == 32)
      {
         ConsolePrint("Maximum players reached !...Cannot create bot...!\n");
      }
		else
	{
    //------------------------------------------------------------------------------- 
    // Assign the bot a name !
	if (Name == "")
	{
	Name = g_Bot_Default_English_Names[g_BotNamesIndex];
    g_BotNamesIndex = g_BotNamesIndex+1;
	}
	//-------------------------------------------------------------------------------
	// Call the game engine to create the fake client
	 bot = CREATE_FAKE_CLIENT( Name );
	// Set the fakeclient flag to entity to tell engine that it is not a real player
	char *infobuffer = GET_KEY_INFOBUFFER(bot);
	char ptr[128];
	SET_CLIENT_KEYVALUE( g_botIndex+1, infobuffer, "model", "gordon");
	SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "rate", "3500");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "cl_updaterate", "20");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "cl_lw", "1");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "cl_lc", "1");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "tracker", "0");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "cl_dlmax", "128");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "lefthand", "1");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "friends", "0");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "dm", "0");
    SET_CLIENT_KEY_VALUE( g_botIndex+1, infobuffer, "_ah", "0");
	ENTITY_SET_KEYVALUE(bot, "_vgui_menus", "0");
	ENTITY_SET_KEYVALUE(bot, "_cl_autowepswitch", "1");
	ENTITY_SET_KEYVALUE(bot, "*bot", "1");
	//-----------------------------------------------------------------------------------
	// Initialize all variables for the BOT
	g_IsBot[g_botIndex+1] = true;				 // Mark this player index as BOT
	s_bot = &m_bot[g_botIndex+1];				 // Add the bot in the bot array
	s_bot->pEdict = bot;                         // Set this bot index entity the bot entity
	s_bot->b_IsAlive = true;                     // Set the bot's player flag as alive
	s_bot->b_SlotUsed = true;                    // Set the bot's player slot as used
	g_NumberOfBots++;					         // Set the number of bots to +1
	g_botIndex++;
	s_bot->pEdict->v.flags |= FL_FAKECLIENT;     // Mark this player's flags as FakeClient
	//-----------------------------------------------------------------------------------
	s_bot->b_HasEnteredGame = true;						// Mark this bot that has entered the game but not spawned
	s_bot->b_HasSpawned = false;						// Mark this bot that has not spawned yet in the game
	s_bot->f_CurrentVoicePitch = RANDOM_FLOAT(50,100);  // Assign this bot a random voice pitch
	//---------------------------------------------------------------------------------
	// Assign a team to the bot
	if (Team == -1)
    s_bot->i_SelectedTeam = (int)RANDOM_LONG(TEAM_TERRORIST,TEAM_COUNTER_TERRORIST); // assign a random team
	else
	s_bot->i_SelectedTeam = Team;
	// Assign a model to the team
	//---------------------------------------------------------------------------------
    if (s_bot->i_SelectedTeam == TEAM_TERRORIST) // if team is Terrorist, assign a terrorist model
	{
		if (Model == "arctic")
        s_bot->i_SelectedModel = MODEL_ARCTIC;
		else if (Model == "guerilla")
		s_bot->i_SelectedModel = MODEL_GUERILLA;
		else if (Model == "leet")
		s_bot->i_SelectedModel = MODEL_LEET;
		else if (Model == "terror")
		s_bot->i_SelectedModel = MODEL_TERROR;
		else if (Model == "militia" && ConditionZeroModelsExist(true,false)) // check for condition-zero model
		s_bot->i_SelectedModel = MODEL_CZ_MILITIA;
		// assign the bot a random model
		if ( ConditionZeroModelsExist(true,false))
		{
        s_bot->i_SelectedModel = (int)RANDOM_LONG(MODEL_ARCTIC,MODEL_CZ_MILITIA);
		}
		else
        s_bot->i_SelectedModel = (int)RANDOM_LONG(MODEL_ARCTIC,MODEL_TERROR);
	
	}
	else if (s_bot->i_SelectedTeam == TEAM_COUNTER_TERRORIST) // if team is Counter-Terrorist, assign a counter-terrorist model
	{

        if (Model == "gign")
        s_bot->i_SelectedModel = MODEL_GIGN;
		else if (Model == "gsg9")
		s_bot->i_SelectedModel = MODEL_GSG9;
		else if (Model == "sas")
		s_bot->i_SelectedModel = MODEL_SAS;
		else if (Model == "urban")
		s_bot->i_SelectedModel = MODEL_URBAN;
		else if (Model == "spetsnaz" && ConditionZeroModelsExist(false,true)) // check for condition-zero model
		s_bot->i_SelectedModel = MODEL_CZ_SPETSNAZ;
		// assign the bot a random model
		if ( ConditionZeroModelsExist(false,true))
		{
        s_bot->i_SelectedModel = (int)RANDOM_LONG(MODEL_GIGN,MODEL_CZ_SPETSNAZ);
		}
		else
        s_bot->i_SelectedModel = (int)RANDOM_LONG(MODEL_GIGN,MODEL_URBAN);
	}

	//---------------------------------------------------------------------------------
	s_bot->pickup_item = NULL;
	s_bot->v_origin = bot->v.origin;
	// Update the bot's name
	s_bot->i_SelectedName = Name;
	// Bot has no kills yet !
	s_bot->i_CurrentFrags = 0;
	// assign a profile type for the bot
	if(Profile == PROFILE_NORMAL)
	s_bot->i_CurrentPersonality = PROFILE_NORMAL;
	else if(Profile == PROFILE_AGGRESSIVE)
	s_bot->i_CurrentPersonality = PROFILE_AGGRESSIVE;
	else if(Profile == PROFILE_DEFENSIVE)
	s_bot->i_CurrentPersonality = PROFILE_DEFENSIVE;
	else
	s_bot->i_CurrentPersonality = (int)RANDOM_LONG(PROFILE_NORMAL,PROFILE_DEFENSIVE);
	s_bot->enemy = NULL; // no enemy yet
	// assign a skill to the bot
	if (Skill = -1) // assign a random skill
    s_bot->i_CurrentSkill = (int)RANDOM_LONG(g_Cvar_BotMinSkill,g_Cvar_BotMaxSkill);
	else
	s_bot->i_CurrentSkill = Skill;
	// after assigning a skill it's time to initialize the bot's skill items
	//----------------------------------------------------------------------
	InitializeBotSkill(s_bot);
    //----------------------------------------------------------------------
	if (bot != NULL)
	{
	// Format the connect message with the selected name, team & skill !
	sprintf_s(connectMessage,"[CounterBot_mm] Connecting %s, on the %d team with skill %d \n",s_bot->i_SelectedName,s_bot->i_SelectedTeam,s_bot->i_CurrentSkill);
	ConsolePrint(connectMessage); // Print a message to the console that the bot is connecting !
	// if Debug Mode is enabled print a message telling bot creation was succesfull !
	if (g_IsDebugMode)
	ConsolePrint("[DEBUG] - BOT succesfully created...! \n");
	}
	// Connect the bot to the server with the default fake IP adress: "127.0.0.1"
	MDLL_ClientConnect( bot, Name, "127.0.0.1", ptr );
	// Put the bot in the server...Bot automatically joins in spectator mode
	MDLL_ClientPutInServer( bot );
  }
  }
}
//========================================================================================
// CREATE RANDOM BOT - Creates a bot upon random parameters
//========================================================================================
void CreateRandomBot(void)
{
	CreateBot("",-1,"",-1,-1);
}
//========================================================================================
void KillBot(Bot_t *bot) // Kills a bot player
{
}
//========================================================================================
void KillAllBots(void) // Kills all bots
{
}
//========================================================================================
void RemoveBot(Bot_t *bot) // Kicks a bot player from the game
{
}
//========================================================================================
void SetPingTag(Bot_t *bot, char pingTag)
{
}
//========================================================================================
//========================================================================================
//
//										  WAYPOINTS
//
//========================================================================================
//========================================================================================
// 
//										START ENGINE DLL
//
//========================================================================================
static DLL_FUNCTIONS gFunctionTable = 
{

	NULL,					// pfnGameInit

	NULL,					// pfnSpawn

	NULL,					// pfnThink

	NULL,					// pfnUse

	NULL,					// pfnTouch

	NULL,					// pfnBlocked

	NULL,					// pfnKeyValue

	NULL,					// pfnSave

	NULL,					// pfnRestore

	NULL,					// pfnSetAbsBox



	NULL,					// pfnSaveWriteFields

	NULL,					// pfnSaveReadFields



	NULL,					// pfnSaveGlobalState

	NULL,					// pfnRestoreGlobalState

	NULL,					// pfnResetGlobalState



	NULL,					// pfnClientConnect

	NULL,					// pfnClientDisconnect

	NULL,					// pfnClientKill

	NULL,					// pfnClientPutInServer

	NULL,					// pfnClientCommand

	NULL,					// pfnClientUserInfoChanged

	NULL,					// pfnServerActivate

	NULL,					// pfnServerDeactivate



	NULL,					// pfnPlayerPreThink

	NULL,					// pfnPlayerPostThink



	NULL,					// pfnStartFrame

	NULL,					// pfnParmsNewLevel

	NULL,					// pfnParmsChangeLevel



	NULL,					// pfnGetGameDescription

	NULL,					// pfnPlayerCustomization



	NULL,					// pfnSpectatorConnect

	NULL,					// pfnSpectatorDisconnect

	NULL,					// pfnSpectatorThink

	

	NULL,					// pfnSys_Error



	NULL,					// pfnPM_Move

	NULL,					// pfnPM_Init

	NULL,					// pfnPM_FindTextureType

	

	NULL,					// pfnSetupVisibility

	NULL,					// pfnUpdateClientData

	NULL,					// pfnAddToFullPack

	NULL,					// pfnCreateBaseline

	NULL,					// pfnRegisterEncoders

	NULL,					// pfnGetWeaponData

	NULL,					// pfnCmdStart

	NULL,					// pfnCmdEnd

	NULL,					// pfnConnectionlessPacket

	NULL,					// pfnGetHullBounds

	NULL,					// pfnCreateInstancedBaselines

	NULL,					// pfnInconsistentFile

	NULL,					// pfnAllowLagCompensation
};

//========================================================================================
// DLL FUNCTIONS DECLARATIONS
//========================================================================================
void WINAPI GiveFnptrsToDll (enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals);
void ServerActivate (edict_t *pEdictList, int edictCount, int clientMax);
int  EntitySpawn(edict_t *pent);
void StartFrame (void);
void PlayerThink(edict_t *pent);
//========================================================================================
//========================================================================================
//========================================================================================
// METAMOD Start
enginefuncs_t meta_engfuncs;
gamedll_funcs_t *gpGamedllFuncs;
mutil_funcs_t *gpMetaUtilFuncs;
meta_globals_t *gpMetaGlobals;
//========================================================================================
META_FUNCTIONS gMetaFunctionTable =
{
   NULL, // pfnGetEntityAPI()
   NULL, // pfnGetEntityAPI_Post()
   GetEntityAPI2, // pfnGetEntityAPI2()
   NULL, // pfnGetEntityAPI2_Post()
   NULL, // pfnGetNewDLLFunctions()
   NULL, // pfnGetNewDLLFunctions_Post()
   GetEngineFunctions, // pfnGetEngineFunctions()
   NULL, // pfnGetEngineFunctions_Post()
};
//========================================================================================
plugin_info_t Plugin_info = {
   META_INTERFACE_VERSION,						// interface version
   PLUGIN_NAME,									// plugin name
   PLUGIN_VERSION,								// plugin version
   PLUGIN_DATE,									// plugin date of creation
   PLUGIN_AUTHOR,								// plugin author
   PLUGIN_URL,									// plugin URL
   PLUGIN_LOGTAG,								// plugin logtag
   PT_CHANGELEVEL,								// when loadable
   PT_ANYTIME,									// when unloadable
};
//========================================================================================
C_DLLEXPORT int Meta_Query (char *ifvers, plugin_info_t **pPlugInfo, mutil_funcs_t *pMetaUtilFuncs)
{
   // this function is the first function ever called by metamod in the plugin DLL. Its purpose
   // is for metamod to retrieve basic information about the plugin, such as its meta-interface
   // version, for ensuring compatibility with the current version of the running metamod.

   // keep track of the pointers to metamod function tables metamod gives us
   gpMetaUtilFuncs = pMetaUtilFuncs;
   *pPlugInfo = &Plugin_info;

   // check for interface version compatibility
   if (strcmp (ifvers, Plugin_info.ifvers) != 0)
   {
      int mmajor = 0, mminor = 0, pmajor = 0, pminor = 0;

      LOG_CONSOLE (PLID, "%s: meta-interface version mismatch (metamod: %s, %s: %s)", Plugin_info.name, ifvers, Plugin_info.name, Plugin_info.ifvers);
      LOG_MESSAGE (PLID, "%s: meta-interface version mismatch (metamod: %s, %s: %s)", Plugin_info.name, ifvers, Plugin_info.name, Plugin_info.ifvers);

      // if plugin has later interface version, it's incompatible (update metamod)
      sscanf_s (ifvers, "%d:%d", &mmajor, &mminor);
      sscanf_s (META_INTERFACE_VERSION, "%d:%d", &pmajor, &pminor);

      if ((pmajor > mmajor) || ((pmajor == mmajor) && (pminor > mminor)))
      {
         LOG_CONSOLE (PLID, "metamod version is too old for this plugin; update metamod");
         LOG_ERROR (PLID, "metamod version is too old for this plugin; update metamod");
         return (FALSE);
      }

      // if plugin has older major interface version, it's incompatible (update plugin)
      else if (pmajor < mmajor)
      {
         LOG_CONSOLE (PLID, "metamod version is incompatible with this plugin; please find a newer version of this plugin");
         LOG_ERROR (PLID, "metamod version is incompatible with this plugin; please find a newer version of this plugin");
         return (FALSE);
      }
   }
   return (TRUE); // tell metamod this plugin looks safe
}
//========================================================================================
// REGISTER CVARS - Register your CVars here...
//========================================================================================
void Register_CVars(void)
{
// Aiming cvars
CVAR_REGISTER(&CVAR_AIM_DAMPERCOEFF_X);
CVAR_REGISTER(&CVAR_AIM_DAMPERCOEFF_Y);
CVAR_REGISTER(&CVAR_AIM_DEVIATION_X);
CVAR_REGISTER(&CVAR_AIM_DEVIATION_Y);
CVAR_REGISTER(&CVAR_AIM_INFLUENCE_X_ON_Y);
CVAR_REGISTER(&CVAR_AIM_INFLUENCE_Y_ON_X);
CVAR_REGISTER(&CVAR_AIM_NOTARGET_SLOWDOWN_RATIO_X);
CVAR_REGISTER(&CVAR_AIM_OFFSET_DELAY);
CVAR_REGISTER(&CVAR_AIM_SPRING_STIFFNESS_X);
CVAR_REGISTER(&CVAR_AIM_SPRING_STIFFNESS_Y);
CVAR_REGISTER(&CVAR_AIM_TARGET_ANTICIPATION_RATIO);
//----------------------------------------------------------------------------------------
CVAR_REGISTER(&CVAR_BOT_AUTOFOLLOW_PERCENT);
CVAR_REGISTER(&CVAR_BOT_MINSKILL);
CVAR_REGISTER(&CVAR_BOT_MAXSKILL);
CVAR_REGISTER(&CVAR_BOT_DEBUG); 
CVAR_REGISTER(&CVAR_BOT_MINBOTS);
CVAR_REGISTER(&CVAR_BOT_MAXBOTS);
CVAR_REGISTER(&CVAR_BOT_AUTOVACATE);
CVAR_REGISTER(&CVAR_BOT_BUY);
CVAR_REGISTER(&CVAR_BOT_SHOOT);
CVAR_REGISTER(&CVAR_BOT_WALK_ONLY);
CVAR_REGISTER(&CVAR_BOT_STOP);
CVAR_REGISTER(&CVAR_BOT_DEATHMATCH);
CVAR_REGISTER(&CVAR_BOT_EXTREME_MODE);
CVAR_REGISTER(&CVAR_BOT_PREFIX);
CVAR_REGISTER(&CVAR_BOT_SKILL_SUFIX); 
CVAR_REGISTER(&CVAR_BOT_VOICE_PATH); 
CVAR_REGISTER(&CVAR_TURN_METHOD);
CVAR_REGISTER(&CVAR_BOT_CHATTER_TYPE); 
CVAR_REGISTER(&CVAR_BOT_JOIN_TEAM);
CVAR_REGISTER(&CVAR_KNIFE_MODE);
CVAR_REGISTER(&CVAR_PISTOL_MODE);
CVAR_REGISTER(&CVAR_SHOTGUN_MODE);
CVAR_REGISTER(&CVAR_SUBMACHINE_GUN_MODE);
CVAR_REGISTER(&CVAR_MACHINE_GUN_MODE);
CVAR_REGISTER(&CVAR_RIFLE_MODE);
CVAR_REGISTER(&CVAR_SNIPER_MODE);
CVAR_REGISTER(&CVAR_ALL_WEAPONS);
CVAR_REGISTER(&CVAR_RESTRICT_PISTOLS);
CVAR_REGISTER(&CVAR_RESTRICT_SHOTGUNS);
CVAR_REGISTER(&CVAR_RESTRICT_SUBMACHINE_GUNS);
CVAR_REGISTER(&CVAR_RESTRICT_MACHINE_GUNS);
CVAR_REGISTER(&CVAR_RESTRICT_RIFLES);
CVAR_REGISTER(&CVAR_RESTRICT_SNIPERS);
CVAR_REGISTER(&CVAR_RESTRICT_GRENADES);
CVAR_REGISTER(&CVAR_THINK_FPS);
CVAR_REGISTER(&CVAR_PICKUP_ITEM_DELAY);
CVAR_REGISTER(&CVAR_HEARING_DELAY);
// Bot Dll Info - not changeable...
CVAR_REGISTER(&CVAR_BOT_VERSION);
REG_SVR_COMMAND("create_bot",CreateRandomBot);
}
//========================================================================================
C_DLLEXPORT int Meta_Attach (PLUG_LOADTIME now, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals, gamedll_funcs_t *pGamedllFuncs)
{
   // this function is called when metamod attempts to load the plugin. Since it's the place
   // where we can tell if the plugin will be allowed to run or not, we wait until here to make
   // our initialization stuff, like registering CVARs and dedicated server commands.

   // are we allowed to load this plugin now ?
   if (now > Plugin_info.loadable)
   {
      LOG_CONSOLE (PLID, "%s: plugin NOT attaching (can't load plugin right now)", Plugin_info.name);
      LOG_ERROR (PLID, "%s: plugin NOT attaching (can't load plugin right now)", Plugin_info.name);
      return (FALSE); // returning FALSE prevents metamod from attaching this plugin
   }

   // keep track of the pointers to engine function tables metamod gives us
   gpMetaGlobals = pMGlobals;
   memcpy (pFunctionTable, &gMetaFunctionTable, sizeof (META_FUNCTIONS));
   gpGamedllFuncs = pGamedllFuncs;

   // print a message to notify about plugin attaching
   LOG_CONSOLE (PLID, "%s: plugin attaching", Plugin_info.name);
   LOG_MESSAGE (PLID, "%s: plugin attaching", Plugin_info.name);

   //=====================================================================================
   //=====================================================================================
      LoadConfigurationFiles();			// Load the configuration files
      Register_CVars();					// Register bot DLL cvars
   //=====================================================================================
   //=====================================================================================

   return (TRUE); // returning TRUE enables metamod to attach this plugin
}
//========================================================================================
C_DLLEXPORT int Meta_Detach (PLUG_LOADTIME now, PL_UNLOAD_REASON reason)
{
   // this function is called when metamod unloads the plugin. A basic check is made in order
   // to prevent unloading the plugin if its processing should not be interrupted.

   // is metamod allowed to unload the plugin ?
   if ((now > Plugin_info.unloadable) && (reason != PNL_CMD_FORCED))
   {
      LOG_CONSOLE (PLID, "%s: plugin NOT detaching (can't unload plugin right now)", Plugin_info.name);
      LOG_ERROR (PLID, "%s: plugin NOT detaching (can't unload plugin right now)", Plugin_info.name);
      return (FALSE); // returning FALSE prevents metamod from unloading this plugin
   }

   return (TRUE); // returning TRUE enables metamod to unload this plugin
}
//========================================================================================
C_DLLEXPORT int GetEntityAPI2 (DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion)
{
   gFunctionTable.pfnServerActivate = ServerActivate;
   gFunctionTable.pfnSpawn = EntitySpawn;
   gFunctionTable.pfnStartFrame = StartFrame;
   gFunctionTable.pfnThink = PlayerThink;

   memcpy (pFunctionTable, &gFunctionTable, sizeof (DLL_FUNCTIONS));
   return (TRUE);
}
//========================================================================================
C_DLLEXPORT int GetEngineFunctions (enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion)
{
   meta_engfuncs.pfnMessageBegin = pfnMessageBegin;
   meta_engfuncs.pfnMessageEnd = pfnMessageEnd;
   meta_engfuncs.pfnRunPlayerMove = pfnRunPlayerMove;
   meta_engfuncs.pfnRegUserMsg = pfnRegUserMsg;
   memcpy (pengfuncsFromEngine, &meta_engfuncs, sizeof (enginefuncs_t));
   return (TRUE);
}

// METAMOD End
//========================================================================================
//========================================================================================
//========================================================================================
#ifdef _WIN32
BOOL WINAPI DllMain (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
   return (TRUE); // required Win32 DLL entry point
}
#endif
//========================================================================================
void WINAPI GiveFnptrsToDll (enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals)
{  
	// get the engine functions from the engine...
   memcpy (&g_engfuncs, pengfuncsFromEngine, sizeof (enginefuncs_t));
   gpGlobals = pGlobals;

}
//========================================================================================
void ServerActivate (edict_t *pEdictList, int edictCount, int clientMax)
{
   RETURN_META (MRES_IGNORED);
}
//========================================================================================
int EntitySpawn(edict_t *pent)
{
	if (strcmp (STRING (pent->v.classname), "worldspawn") == 0)
   {
      g_MapType = 0; // reset Map Type as worldspawn is the first entity spawned
   }
	else if (strcmp (STRING (pent->v.classname), "info_player_start") == 0)
   {
	  SET_MODEL (pent, "models/player/urban/urban.mdl"); // set the default model view
	  pent->v.rendermode = kRenderTransAlpha; // set its render mode to transparency
      pent->v.renderamt = 127; // set its transparency amount
      pent->v.effects |= EF_NODRAW;
   }
	else if (strcmp (STRING (pent->v.classname), "info_player_deathmatch") == 0)
   {
      SET_MODEL (pent, "models/player/terror/terror.mdl"); // set the default model view
      pent->v.rendermode = kRenderTransAlpha; // set its render mode to transparency
      pent->v.renderamt = 127; // set its transparency amount
      pent->v.effects |= EF_NODRAW;
   }
	else if (strcmp (STRING (pent->v.classname), "info_vip_start") == 0)
   {    
      SET_MODEL (pent, "models/player/vip/vip.mdl"); // set the default model view
      pent->v.rendermode = kRenderTransAlpha; // set its render mode to transparency
      pent->v.renderamt = 127; // set its transparency amount
      pent->v.effects |= EF_NODRAW;
   }
	// Setup the map type
	else if ((strcmp (STRING (pent->v.classname), "func_vip_safetyzone") == 0) || (strcmp (STRING (pent->v.classname), "info_vip_safetyzone") == 0))     
      g_MapType |= MAP_TYPE_AS;	  // assassination map
	else if (strcmp (STRING (pent->v.classname), "hostage_entity") == 0)
      g_MapType |= MAP_TYPE_CS;   // hostage rescue map
	else if ((strcmp (STRING (pent->v.classname), "func_bomb_target") == 0) || (strcmp (STRING (pent->v.classname), "info_bomb_target") == 0))         
      g_MapType |= MAP_TYPE_DE;   // bomb defuse map
	else if ((strcmp (STRING (pent->v.classname), "func_escapezone") == 0))           
      g_MapType |= MAP_TYPE_ES;   // escape map
	else
      g_MapType |= MAP_TYPE_DEATHMATCH; // unknown map type, assume deathmatch

	// Insert your code here...
	RETURN_META_VALUE(MRES_IGNORED, 0);
}
//========================================================================================
//========================================================================================
// START FRAME - Main loop of the DLL - gets called every video frame
//========================================================================================
void StartFrame (void)
{   
	// temp variables
	float thinkFPS_delay = CVAR_GET_FLOAT("cb_think_fps_delay");

	// Check if server map restart command has been issued
	if(g_RestartServerTimer > 0 && g_RestartServerTimer < GetWorldTime())
	{
	  g_RestartServerTimer = 0;    // Prevent map from restarting over and over again
      SERVER_COMMAND("restart\n"); // restart server map
	}

	// Do not allow the FPS delay timer to be less than 0 and higher than 1
	//---------------------------------------------------------------------
	if (thinkFPS_delay <= 0.0 || thinkFPS_delay > 1.0)
	{
		CVAR_SET_FLOAT("cb_think_fps_delay",0.5);
	}
	//---------------------------------------------------------------------
	for (int i = 0; i < g_NumberOfBots; i++)
   {
      if (g_IsBot[i] && m_bot[i].pEdict != NULL)
	  {
		  if (FPS_timer < GetWorldTime())
		  {
			  // START BOT ARTIFICIAL INTELLIGENCE
		/*	<<<<<<<< */ BotAI(&m_bot[i]); /*  >>>>>>>> */

		  // Adjust the FPS think timer...
		  FPS_timer = GetWorldTime () + (1 * thinkFPS_delay) / RANDOM_FLOAT(0.97, 1.05);
		  } 
	  }
	}
   //---------------------------------------------------------------------
   // Insert your code here...
   RETURN_META (MRES_IGNORED);
}
//========================================================================================
// PLAYER THINK - NOT USED
//========================================================================================
void PlayerThink ( edict_t *pent )
{
   // Insert your code here...
   RETURN_META (MRES_IGNORED);
}
//========================================================================================
// 
//										  END ENGINE DLL
//
//========================================================================================

